
#include "TestExecutor.h"
#include <thread>
#include <sys/time.h>
#include <sys/resource.h>

TestExecutor::TestExecutor() {
    finished = false;
    stop = false;
    connectionReuse = true;
}

void TestExecutor::execute() {
    rusage initial{};
    rusage final{};

    getrusage(RUSAGE_SELF, &initial);
    std::thread t1([this]() {
        run();
        finished = true;
    });

    t1.detach();

    std::this_thread::sleep_for(std::chrono::seconds(TEST_RUN_SECONDS_DURATION));
    stop = true;

    while (!finished) {

    }

    getrusage(RUSAGE_SELF, &final);

    time_t userModeCpuSecs = final.ru_utime.tv_sec - initial.ru_utime.tv_sec;
    time_t kernelModeCpuSecs = final.ru_stime.tv_sec - initial.ru_stime.tv_sec;
    tracer->traceCpuKernelUsage(kernelModeCpuSecs);
    tracer->traceCpuUserUsage(userModeCpuSecs);

    std::this_thread::sleep_for(std::chrono::seconds(5));
}

TestExecutor::~TestExecutor() {
    delete tracer;
}
