#ifndef CODE_THREADEDEXECUTOR_H
#define CODE_THREADEDEXECUTOR_H

#include "../TestExecutor.h"
#include <fmt/core.h>

class ThreadedExecutor : public TestExecutor {
public:
    ThreadedExecutor(std::string ip, int port, int threadCount, int delay, bool connectionReuse) {
        std::string description = fmt::format("threaded-{}t-{}d-{}r", threadCount, delay, (int)connectionReuse);
        this->ip = ip;
        this->port = port;
        this->tracer = new Tracer(description);
        this->connectionReuse = connectionReuse;
        this->concurrentConnections = threadCount;
        this->delay = delay;
    }
    void run() override;

private:
    void fork();
    void thread_work();
};


#endif //CODE_THREADEDEXECUTOR_H
