package main

import (
	"bufio"
	"fmt"
	"log"
	"net"
	"strconv"
	"time"
)

func main() {
	l, err := net.Listen("tcp4", ":7777")

	if err != nil {
		log.Fatal(err)
	}

	defer l.Close()

	for {
		conn, err := l.Accept()

		if err != nil {
			fmt.Println(err)
			return
		}

		go handleConnection(conn)
	}
}

func handleConnection(c net.Conn) {
	defer c.Close()
	for {
		data, err := bufio.NewReader(c).ReadString('\n')

		if err != nil {
			fmt.Println(err)
			return
		}

		str_data := string(data)

		delay, _ := strconv.Atoi(str_data[:len(str_data)-1])

		fmt.Println(delay)

		time.Sleep(time.Duration(delay) * time.Millisecond)

		c.Write([]byte("Lorem Ipsum\n"))
	}
}
